
// Author Zecronious
// Date 31/08/2013
//-------------------

// The Avatar
//-------------------
// This is what the player owns

Avatar
	parent_type = /Mobile

	var
		// Player Set Variables
		//-------------------
		mob/owner // The player who owns this avatar
		active    // Will only activate when it's owner has been set
		name
		damage

		// Avatar Variables
		//-------------------

		list/unlockedAreas = list()
		Journal/journal

		exp = 0
		treasure = 0
		nextExp = 0
		level = 0

		savedAction // Used to identify if an action is underway that takes more than one tick.
			/*
			Unused : 0
			Combat : 1
			*/

		savedProgress // For example (10 health left) Used to keep track of progress in a repeating action.
		savedObject   // For example "Ogre" or "Tree"
		savedLocation // Used to identify the location of the saved action.

	proc
		// Called every time the ticker updates
		Action()

			// Make sure the avatar is in a position to act
			if(!savedAction)
				if(active && location)
					var/action = rand(1,100)
					if(action < 20) Find_Treasure()
					else Find_Monster()

				else Default_Screen()

			else if(savedLocation == location)
				if(savedAction == 1) Find_Monster(savedObject, savedProgress)

			else
				savedLocation = 0
				savedAction = 0

			owner.Write(new/savefile(owner.saveDir))

		Find_Treasure()

			// Get a random monster type from the list
			var/randPick = rand(1, location.treasure.len)
			var/Treasure/randTreasure = location.treasure[randPick]
			var/gainedTreasure = round(rand(randTreasure.value / 2, randTreasure.value))

			// Assume you won
			Add_Value(gainedTreasure)

			// Now output the result of the encounter
			owner.Game_Clear()
			owner.Game_Out(line_bar)
			owner.Game_Out("| [f_cyan][name][f_end] | Level: [f_cyan][level][f_end] | Treasure: [f_yellow][num2commaNum(treasure)][f_end] | EXP Needed: [f_blue][num2commaNum(nextExp - exp)][f_end] |")
			owner.Game_Out("\nUnearthed [randTreasure.namePrefix] [f_green][randTreasure.name][f_end]: Gained [f_yellow][gainedTreasure] Treasure.[f_end]")
			owner.Game_Out(line_bar)

		Find_Monster(Monster/savedMonster, savedHealth)

			if(!savedMonster)

				// Get a random monster type from the list
				var/randPick = rand(1, location.monsters.len)
				var/Monster/randMonster = location.monsters[randPick]
				var/randDamage = rand(damage,damage * 2)
				if(randDamage >= randMonster.health) randDamage = randMonster.health
				var/gainedExp = round(rand(randMonster.maxExp * randDamage / 2, randMonster.maxExp * randDamage))

				// Assume you won
				Add_Exp(gainedExp)

				// Now output the result of the encounter
				owner.Game_Clear()
				owner.Game_Out(line_bar)
				owner.Game_Out("| [f_cyan][name][f_end] | Level: [f_cyan][level][f_end] | Treasure: [f_yellow][num2commaNum(treasure)][f_end] | EXP Needed: [f_blue][num2commaNum(nextExp - exp)][f_end] |")

				if(randDamage != randMonster.health)
					owner.Game_Out("\nDiscovered [randMonster.namePrefix] [f_green][randMonster.name][f_end] and attacked it. Did [f_red][randDamage] Damage[f_end]. Gained [f_blue][gainedExp] EXP.[f_end]")
					savedProgress   = randMonster.health - randDamage
					savedObject    = randMonster
					savedLocation  = location
					savedAction = 1
				else
					owner.Game_Out("\nDiscovered [randMonster.namePrefix] [f_green][randMonster.name][f_end] and killed it. Did [f_red][randDamage] Damage[f_end]. Grained [f_blue][gainedExp] EXP.[f_end]")
				owner.Game_Out(line_bar)

			else

				// Use the saved monster and progress
				var/randDamage = rand(damage,damage * 2)
				if(randDamage >= savedHealth) randDamage = savedHealth
				var/gainedExp = round(rand(savedMonster.maxExp * randDamage / 2, savedMonster.maxExp * randDamage))

				// Assume you won
				Add_Exp(gainedExp)

				// Now output the result of the encounter
				owner.Game_Clear()
				owner.Game_Out(line_bar)
				owner.Game_Out("| [f_cyan][name][f_end] | Level: [f_cyan][level][f_end] | Treasure: [f_yellow][num2commaNum(treasure)][f_end] | EXP Needed: [f_blue][num2commaNum(nextExp - exp)][f_end] |")

				if(randDamage != savedHealth)
					owner.Game_Out("\nRetaliated against the [f_green][savedMonster.name][f_end]. Did [f_red][randDamage] Damage[f_end]. Gained [f_blue][gainedExp] EXP.[f_end]")
					savedProgress   = savedHealth - damage
				else
					owner.Game_Out("\nRetaliated against the [f_green][savedMonster.name][f_end] and killed it. Did [f_red][randDamage] Damage[f_end]. Grained [f_blue][gainedExp] EXP.[f_end]")
					savedMonster  = 0
					savedLocation = 0
					savedProgress = 0
					savedAction   = 0

				owner.Game_Out(line_bar)

		Default_Screen()

			owner.Game_Clear()
			owner.Game_Out(line_bar)
			owner.Game_Out("| [f_cyan][name][f_end] | Level: [f_cyan][level][f_end] | Treasure: [f_yellow][num2commaNum(treasure)][f_end] | EXP Needed: [f_blue][num2commaNum(nextExp - exp)][f_end] |\n\n")
			owner.Game_Out(line_bar)

		// Called when the avatar is created
		Load()

			Calculate_Next_Exp(level)
			Move_To(theWorld.areas[1])

		// Does extra
		Add_Exp(amount)

			if(amount > 0)
				exp += amount
				Calculate_Next_Exp()

		// Does extra
		Add_Value(amount)

			if(amount > 0)
				treasure += amount

		// Flags the avatar as useable, once it's loaded
		Activate(newOwner)

			owner = newOwner
			name = owner.name
			active = 1

		// Sets the new amount of exp the avater needs for a new level
		Calculate_Next_Exp()

			// They might level more than once
			while(exp >= nextExp)
				level ++
				nextExp = round((level * 30) ** 1.8)
				Refresh_Player_Lists()

		Add_Journal()

			journal = new/Journal()

		Add_Default_Areas()

			for(var/Area/A in theWorld.areas)
				unlockedAreas.Add(A)

		Add_Default_Journal_Entries()

			journal.contents.Add(new/Journal_Node/The_Beginning)
			journal.contents.Add(new/Journal_Node/The_Ending)

	New()

		spawn(5) // Time to get setup.

			if(owner)
				if(!journal)
					Add_Journal() // Load all the writings into the journal
					Add_Default_Journal_Entries()

				journal.updateJournal()
				owner.Journal_Out(journal.getJournal()) // Output the journal

		Add_Default_Areas()
		..()