
// Author Zecronious
// Date 31/08/2013
//-------------------

// The Interface
//-------------------
// Methods used for interacting with the interface

var
	f_green = "<font color = #00CC00>"
	f_red = "<font color = #FF0000>"
	f_cyan = "<font color = #00FFFF>"
	f_yellow = "<font color = #FFFF00>"
	f_white = "<font color = #FFFFFF>"
	f_brown = "<font color = #996600>"
	f_grey = "<font color = #575757>"
	f_blue = "<font color = #0066FF>"
	f_end= "</font>"

	global/line_bar = "<b>[f_blue]------------------------------------------------------------------------------------------------[f_end]</b>"
	global/line_bar_third = "<b>[f_blue]----------------------------------[f_end]</b>"

mob
	// Show Verbs
	//-------------------
	verb
		Show_Console()

			winset(src,"console","is-visible=true")

		Show_Journal()

			winset(src,"journal","is-visible=true")

		Show_Details()

			winset(src,"details","is-visible=true")

		Change_Room()

			var/Area/chosenRoom = input(usr,"Which room would you like to travel to?","Change Room") in avatar.unlockedAreas + theWorld.areas
			avatar.Move_To(chosenRoom)
			Room_Details_Out(chosenRoom)


	// Input Functions
	//-------------------

		Input(message as text)

			// Output as a message
			Say(message)

	var
		// Spam Protection
		//-------------------
		sayDelay = 15
		sayIsDelayed = 0

	proc

		// World Output
		//-------------------
		Say(message as text)

			// Won't send if the method has been delayed
			if(!sayIsDelayed)

				// Don't let messages which are too long through
				if(length(message) <= 300)

					// Send the message but add a delay until the method reactivates
					World_Chat_Out("[f_cyan][src.name][f_end]: [html_encode(message)]")
					Pause_Chat()

				else
					// Output length error
					src << Chat_Out("Input Error: Message Too Long", "main.chat")

					// Give them the message back to correct
					winset(src, "main.input", "text=\"[message]\"")
			else
				// Give them the message back to wait out the delay
				Return_Message(message)

		// When input is entered, it's deleted. This can be used to send it back
		Return_Message(message)

			winset(src,"main.input","text=\"[message]\"")

		// Stops the player from using Say() again for sayDelay  milliseconds
		Pause_Chat()

			sayIsDelayed = 1
			sleep(sayDelay)
			sayIsDelayed = 0

	// Output Functions
	//-------------------

		// To The Current Player
		//-------------------
		Game_Out(message as text)

			src << output("[message]", "main.game")

		Game_Clear(message as text)

			src << output(null, "main.game")

		Chat_Out(message as text)

			src << output(message, "main.chat")

		Players_Out(message as text)

			src << output(message, "main.players")

		Players_Clear()

			src << output(null, "main.players")

		Journal_Out(message as text)

			src << output(message, "journal.parchment")

		Room_Details_Out(Area/chosenRoom)

			// Clear the old details
			src << output(null, "details.output")

			// Build the details
			var/details = ""
			details += "[line_bar]\n"
			details += "[chosenRoom.name]\n"
			details += "[line_bar]\n"

			details += "Availible Monsters\n\n"
			for(var/Monster/M in chosenRoom.monsters)
				details += "[f_green][M.name][f_end] : [f_cyan]Level [M.level][f_end] : [f_red]Health [M.health][f_end] : [f_cyan]EXP [M.maxExp * M.health][f_end]\n"

			details += "[line_bar]\n"

			details += "Availible Treasure\n\n"
			for(var/Treasure/T in chosenRoom.treasure)
				details += "[f_green][T.name][f_end] : [f_yellow]Value [T.value][f_end]\n"

			details += "[line_bar]\n"

			src << output(details,"details.output")

		// To The World
		//-------------------

		World_Chat_Out(message as text)

			// Find all players
			for(var/client/C)

				// Send to that person
				C.mob.Chat_Out(message)

		// Automatic Screens
		//-------------------

		Title_Screen()

			// Main Chat Output
			Chat_Out("[line_bar]")
			Chat_Out("[f_cyan]# Idle Land | Build 1.06 |")
			Chat_Out("[f_cyan]Author: Zecronious")
			Chat_Out("[line_bar]")
			Chat_Out("[f_cyan]Version Note:[f_end]\nOld savefiles won't work! Delete your savefiles folder.")
			Chat_Out("[line_bar]")
			Chat_Out("Welcome to the strange and wonderful world of an idle game.\nYour character has already been created.\n\nIt will continue to play without you, however it will require you to manage it as time passes. Explore the menus at your own pace.")
			Chat_Out("[line_bar]")

			// Console Output
			src << "[f_cyan]# Console #[f_end]"
			src << "This console is for recording any problems you encounter during the game. It does not effect the game in any way."
			src << ""

		// Player List
		//-------------------

		Update_Player_List()

			// Clear the list of players
			Players_Clear()
			Players_Out(line_bar_third)

			// Find all players
			for(var/client/C)

				// List them
				Players_Out("<i>[f_cyan][C.mob.name][f_end]</i>")
				if(C.mob.avatar != null)
					Players_Out("- Level: [f_cyan][C.mob.avatar.level][f_end]")

			Players_Out(line_bar_third)

		Set_Title_Bar(title)

			winset(src,"main","title=\"[title]\"")