
// Author Zecronious
// Date 31/08/2013
//-------------------

// The Journal
//-------------------
// Stores all the nodes which contain a part of the story

Journal
	var
		list/contents = list()

	proc
		getJournal()

			var/book = ""
			book += line_bar + "\n"
			var/Journal_Node/jNode = null
			for(var/i = 1, i < contents.len+1, i++)
				jNode = contents[i]

				book += "<u>Entry [i]: [jNode.title]\n</u>"

				book += "\n[jNode.writing]\n"
				if(i != contents.len)
					book += "\n"

				book += line_bar + "\n"

			return book

		updateJournal()

			for(var/Journal_Node/JNode in contents)
				JNode.updateNode()


// Journal Node
//-------------------
// These store the actual story elements and are cotnained within a journal object

Journal_Node

	var
		title = ""
		writing = "" // Where the text is stored in memory
		fileName = "" // Where the text is located on disk, in conjuction with the default folder
		defaultFolder = "JournalEntries/" // The default folder of the journal writings

	The_Beginning

		title = "The Beginning of a Journey"
		fileName = "The Beginning"

	// Something in the middle

	The_Ending

		title = "The Ending of a Journey"
		fileName = "The Ending"

	proc
		updateNode()

			// Load the writing into memory
			var/writingLocation = defaultFolder + fileName + ".jrnl"

			if(fexists(writingLocation))
				writing = file2text(writingLocation)

			else world << ("[writingLocation] failed to load.")

	New()

		updateNode()